﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Numerics;
using System.Threading;
//using System.Runtime.InteropServices;

namespace Interaktivni_hra_uzivatele
{
    public partial class KamenUserControl : UserControl
    {
        public KamenUserControl(Barvy barva, int index_X, int index_Y)
        {
            InitializeComponent();
            Location = new Point(index_X * 30, index_Y * 30);
            _barva = barva;
            Refresh();      
        }

        private Barvy _barva;
        public Barvy Barva
        {
            get { return _barva; }
            set
            {
                _barva = value;
                Refresh();
            }
        }

        private bool _checked;
        public bool Checked
        {
            get { return _checked; }
        }
        
        public void Check()
        {
            _checked = true;
            Refresh();
        }

        public void Uncheck()
        {
            _checked = false;
            Refresh();
        }

        private int _x, _y;
        private bool _jeindexovapozice;
        public void MoveTo(int x, int y, bool jeIndexovaPozice) //Pro animaci posunu; pokud jeIndexovaPozice je true, sporítá pozici na základě rozměrů
        {
            _x = x;
            _y = y;
            _jeindexovapozice = jeIndexovaPozice;
            Thread animace = new Thread(new ThreadStart(_moveTo)); // Nové vlákno pro plynulost
        }

        private void _moveTo()
        {
            int x = _x;
            int y = _y;
            bool jeIndexovaPozice = _jeindexovapozice;
            if (jeIndexovaPozice)
            {
                x *= 30;
                y *= 30;
            }

            Vector2 posunVektor = new Vector2(x - this.Location.X, y - this.Location.Y);
            Vector2 posunJednotkovyVektor = posunVektor.ToUnitVector();
            float lenght = posunVektor.Length();
            int lenghtInt = Convert.ToInt32(lenght - lenght % 1); //Kdyby náhodou nebyla délka celé číslo, tak posouvá do celého čísla a nakonec přiřadí finální souřadnice

            for (int i = 1; i <= lenghtInt; i++) // přičítá jednotkový vektor až do konečné celočíselné délky vektoru pro posun
            {
                this.Location = this.Location.Add(posunJednotkovyVektor);
                Thread.Sleep(30);
            }

            this.Location = new Point(x, y); // nakonec přiřadí výslednou pozici
        }

        public int indexX
        {
            get { return this.Location.X / 30; }
            set
            {
                this.Location = new Point(value * 30, this.Location.Y);
                Refresh();
            }
        }

        public int indexY
        {
            get { return this.Location.Y / 30; }
            set
            {
                this.Location = new Point(this.Location.X, value * 30);
                Refresh();
            }
        }

        public void Zmiz() //Pro animaci zmizení
        {

        }

        private void KamenUserControl_Click(object sender, EventArgs e)
        {
            Check();
        }

        private void KamenUserControl_MouseClick(object sender, MouseEventArgs e)
        {
            Check();
        }

        private void KamenPanel_MouseClick(object sender, MouseEventArgs e)
        {
            Check();            
        }

        private void KamenPanel_Paint(object sender, PaintEventArgs e)
        {
            Graphics gr = e.Graphics;

            gr.FillEllipse(new SolidBrush(_barva.ToColor()), 1, 1, 28, 28); // Barva kamene
            gr.DrawEllipse(new Pen(Color.Black, 2), 1, 1, 28, 28); // Ohraničení

            if (_checked) gr.DrawRectangle(new Pen(Color.Red, 2), 0, 0, 30, 30); // Označení
        }

        //public event ClickedEventDelegate ClickedEvent;
    }

    public enum Barvy
    {
        Cervena = 1,
        Zelena = 2,
        Modra = 3,
        Bila = 4,
        Zluta = 5,        
        Fialova = 6       
    }

    internal static partial class Rozsireni
    {
        public static Barvy naBarvy(this int barva) => (barva > 0 && barva < 7) ? (Barvy)barva : Barvy.Cervena;

        public static Color ToColor(this Barvy barva)
        {
            switch (barva)
            {
                case Barvy.Modra:
                    return Color.Blue;
                case Barvy.Bila:
                    return Color.White;
                case Barvy.Zluta:
                    return Color.Yellow;
                case Barvy.Zelena:
                    return Color.Green;
                case Barvy.Fialova:
                    return Color.Violet;
                default:
                    return Color.Red;
            }
        }

        public static Vector2 ToUnitVector(this Vector2 vector) => vector / vector.Length();

        public static Point Add(this Point point, Vector2 vector) => new Point(point.X + (int)vector.X, point.Y + (int)vector.Y);
    }
}
