﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;

namespace Interaktivni_hra_uzivatele
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
            casLabel.Hide();

            for (int i = 0; i < 8; i++)
            {
                _noveSloupceBarvy[i] = new Queue<Barvy>();
                _sloupceBarvy[i] = new List<Barvy>();
            }
        }

        private void bezČasovéhoLimituToolStripMenuItem_Click(object sender, EventArgs e)
        {
            casLabel.Hide();

            _loaded = false;
            StartGame();
        }

        private void sČasovýmLimitemToolStripMenuItem_Click(object sender, EventArgs e)
        {
            TimeSelectForm oknoInterval = new TimeSelectForm();
            DialogResult vysledekVyberuIntervalu = oknoInterval.ShowDialog();
            if (vysledekVyberuIntervalu == DialogResult.OK && Program.UserSelectedTime)
            {
                casLabel.Show();
            }

            _loaded = false;
            StartGame();
        }

        private void LoadAndStart()
        {
            OpenFileDialog otevritDialog = new OpenFileDialog();
            otevritDialog.Multiselect = false;

            DialogResult vysledek = otevritDialog.ShowDialog();

            if (vysledek == DialogResult.OK)
            {
                for (int i = 0; i < 8; i++)
                {
                    _noveSloupceBarvy[i].Clear();
                    _sloupceBarvy[i].Clear();
                }

                hraPanel.Controls.Clear();

                string path = otevritDialog.FileName;

                StreamReader sr = new StreamReader(new FileStream(path, FileMode.Open));

                int lineIndex = 0;
                string line;
                while ((line = sr.ReadLine()) != null)
                {                    
                    if (lineIndex <= 7)
                    {
                        for (int i = 0; i < 8; i++)
                        {
                            Barvy barva = (Barvy)Convert.ToInt32(Convert.ToString(line[i]));
                            _sloupceBarvy[i].Add(barva);
                            hraPanel.Controls.Add(new KamenUserControl(barva, i, lineIndex));
                            hraPanel.Controls[hraPanel.Controls.Count - 1].MouseClick += StoneChecked; 
                        }
                    }
                    else
                    {
                        for (int i = 0; i < line.Length - 1; i++)
                        {
                            Barvy barva = (Barvy)Convert.ToInt32(Convert.ToString(line[i]));
                            _noveSloupceBarvy[lineIndex - 8].Enqueue(barva);
                            if (i == 0) doplnovaciKamenyPanel.Controls.Add(new KamenUserControl(barva, lineIndex - 8, 0));
                        }
                    }

                    lineIndex++;
                }

                _loaded = true;

                StartGame();
            }
        }

        private bool _loaded;
        private void StartGame()
        {
            if (!_loaded)
            {
                Random ran = new Random();
                for (int x = 0; x < 8; x++)
                {
                    for (int y = 0; y < 8; y++)
                    {
                        Barvy barva = (Barvy)ran.Next(1, 6);
                        _sloupceBarvy[x].Add(barva);
                        hraPanel.Controls.Add(new KamenUserControl(barva, x, y));
                    }
                }
                for (int x = 0; x < 8; x++)
                {
                    Barvy barva = (Barvy)ran.Next(1, 6);
                    _noveSloupceBarvy[x].Enqueue(barva);
                    doplnovaciKamenyPanel.Controls.Add(new KamenUserControl(barva, x, 0));
                }
            }
        }

        int stoneCheckedX, stoneCheckedY;
        private void StoneChecked(object sender, EventArgs e)
        {
            
        }

        private Queue<Barvy>[] _noveSloupceBarvy = new Queue<Barvy>[8];
        private List<Barvy>[] _sloupceBarvy = new List<Barvy>[8];

        private void načístHruToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LoadAndStart();
        }
    }
}
